DROP TABLE IF EXISTS user;
DROP TABLE IF EXISTS identity;
DROP TABLE IF EXISTS blog;
DROP TABLE IF EXISTS comment;
DROP TABLE IF EXISTS link;

CREATE TABLE user (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	username TEXT UNIQUE NOT NULL,
	password TEXT NOT NULL,
	email TEXT NOT NULL,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	perm_admin BOOLEAN DEFAULT 0,
	perm_secrets BOOLEAN DEFAULT 0,
	perm_link BOOLEAN DEFAULT 0,
	perm_comment BOOLEAN DEFAULT 1,
	perm_identity BOOLEAN DEFAULT 1
);

CREATE TABLE identity (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	user_id INTEGER NOT NULL,
	name TEXT NOT NULL,
	avatar TEXT,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	FOREIGN KEY (user_id) REFERENCES user (id)
);

CREATE TABLE blog (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	author_id INTEGER NOT NULL,
	title TEXT NOT NULL,
	content TEXT,
	hits INTEGER DEFAULT 0,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	FOREIGN KEY (author_id) REFERENCES identity (id)
);

CREATE TABLE comment (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	author_id INTEGER NOT NULL,
	post_id INTEGER NOT NULL,
	content TEXT NOT NULL,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	FOREIGN KEY (author_id) REFERENCES identity (id),
	FOREIGN KEY (post_id) REFERENCES blog (id)
);

CREATE TABLE link (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	creator_id INTEGER NOT NULL,
	url TEXT NOT NULL,
	name TEXT NOT NULL,
	hits INTEGER DEFAULT 0,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	FOREIGN KEY (creator_id) REFERENCES identity (id)
);